
// ncconfig.js: Javascript for the configuration page of ADH NETCOM


// XMLHttpRequest objects
var sxinit = false;  // initial sequencer
var sxaction = false; // action routine: no data returned
var cxcfgin = false;  // get info from config.cgi; get data back
var cxcfgout = false;   // send into to config.cgi, get confirmation message

// get the xmlHttp request object - browser dependent
if (window.XMLHttpRequest)
  {
  sxinit = new XMLHttpRequest();
  sxaction = new XMLHttpRequest();
  cxcfgin = new XMLHttpRequest();
  cxcfgout = new XMLHttpRequest();
  }
else if (window.ActiveObject)
  {
  sxinit =   new ActiveXObject("Microsoft.XMLHTTP");
  sxaction = new ActiveXObject("Microsoft.XMLHTTP");
  cxcfgin  = new ActiveXObject("Microsoft.XMLHTTP");
  cxcfgout = new ActiveXObject("Microsoft.XMLHTTP");
  }
else
  {
  alert("Browser does not support xmlHttpRequest object - need to upgrade");
  }

// timeoutid's : one for each xmlhHTTP object
var timeoutidinit;
var timeoutidact;
var timeoutidcfgin;
var timeoutidcfgout;

var numtimeouts;  // for sequencer error timeouts
var sequencecount = 10;
var sequencelist = new Array(10);
var sequencendx;
// string tells what to do: start with C or S
// do from top to bottom of page
sequencelist[0] = "CVA";  // main firmware
sequencelist[1]  = "CVR";  // Rabbit firmware
sequencelist[2]  = "SI";    // serial number(s)
sequencelist[3]  = "CIC";  // current IP etc.
sequencelist[4]  = "CPL"  // current values: pressure limits
sequencelist[5]  = "CIX"  // current values: IP info
sequencelist[6]  = "CSX"  // current values: SNMP info
sequencelist[7]  = "CCX"  // current values: SNMP communities
sequencelist[8]  = "CMX"  // current values: serial params
sequencelist[9]  = "CRX"  // current values: alarms: params
sequencelist[10] = "CRM"  // current values: alarms - bit part

// don't need alarm list; now in the HTML code itself
var numalarms;
// set numalarms in a script in the main part
// so if add one, don't have to change the js file

function doalert(str)
// really want to put in alert field - later
  {
  alert(str);
  }

function sysalert(str)
// should be impossible; error in Javascript
  {
  alert("SYSTEM ERROR:\n" + str);
  }


function disorenableall(dis)
  {
  // enable or disable all the user buttons - for initializatin
  document.getElementById("standby").disabled=dis;
  document.getElementById("online").disabled=dis;
  document.getElementById("fetchip").disabled=dis;
  document.getElementById("fetchsnmp").disabled=dis;
  document.getElementById("fetchcmun").disabled=dis;
  document.getElementById("fetchpres").disabled=dis;
  document.getElementById("fetchcomm").disabled=dis;
  document.getElementById("fetchdc").disabled=dis;
  document.getElementById("fetchdc").disabled=dis;
  document.getElementById("submitip").disabled=dis;
  document.getElementById("submitsnmp").disabled=dis;
  document.getElementById("submitcmun").disabled=dis;
  document.getElementById("submitpres").disabled=dis;
  document.getElementById("submitcomm").disabled=dis;
  document.getElementById("submitdc").disabled=dis;
  document.getElementById("submitdc").disabled=dis;
  }


function findkeypos(str)
  {
  // return the position of the "key" in str
  // key can be ! or _ or : or ^
  // has to be 0, 1, or 2: else no key, return0
  var pos;
  pos = str.search(/[\!\:\_\^]/);
  if (pos==-1) pos=0;
  if (pos>2) pos=0;
  return pos;
  }


function config_initialize()
  {
  // start sequencer
  sequencendx=0;
  numtimeouts=0;
  disorenableall(1);  // no user input allowed
  dosequencer();  // will enable buttons and start refresh when done
  }


function dosequencer()
  {
  var url;
  var ajaxmsg;
  var x;
  x=sequencelist[sequencendx].charAt(0);
  if (x=='C') url="config.cgi";
  else if (x=='S') url="status.cgi";
  else
    {
    doalert("Bad sequencer element - aborting");
    return;
    }
  ajaxmsg = sequencelist[sequencendx].slice(1);  // start after first char
  if ( (sxinit.readyState==4) || (sxinit.readyState==0) )
    {
    sxinit.open("POST", url, true);
    sxinit.onreadystatechange = sxinitreturn;
    sxinit.send(ajaxmsg);
    timeoutidinit = window.setTimeout("timeoutrtninit();", 1000);
    }
  else
    {
    doalert("Sequencer stuck - aborting");
    return;
    }
  }


function timeoutrtninit()
  {
  // get here if sequencer times out - allow 5 before alerting
  sxinit.abort();
  numtimeouts++;
  if (numtimeouts>=5)
    doalert("Warning: initializer has failed " + numtimeouts + " times so far");
  dosequencer();  // continue to try
  }

function sxinitreturn()
  {
  var str0;
  var keypos;
  var str1;
  var splitstr;
  // check to see if finished
  if ( (sxinit.readyState==4) && (sxinit.status==200) )
    {
    // get it! process
    window.clearTimeout(timeoutidinit);
    numtimeouts=0;
    str0 = sxinit.responseText;
    keypos = findkeypos(str0);
    if (str0.charAt(keypos) != ":")
      {
      // error return - should be impossible
      doalert("Unexpected response [" + str0 + "]");
      dosequencer();  // keep retrying
      return;
      }
    // here, is ok
    // we know where it came from: don't need to parse
    str1 = str0.slice(keypos+1);
    badresp=0;  // default
    if (sequencendx==0)
	{
	// VA to config: get main firmware
	splitarray = str1.split("$");
	if (splitarray.length!=4) badresp=1;
	document.getElementById("mainfw").innerHTML = splitarray[0];
	}
    else if (sequencendx==1)
	{
	// VR to config: get comm firmware
	document.getElementById("commfw").innerHTML = str1;
	}
    else if (sequencendx==2)
	{
	// I to status: get serial numbers
	splitarray = str1.split(";");
	if (splitarray.length!=3) badresp=1;
	document.getElementById("sernum").innerHTML = splitarray[2];
	}
    else if (sequencendx==3)
	{
	// IC to config: current IP etc.
	splitarray = str1.split(";");
	if (splitarray.length!=6) badresp=1;
	document.getElementById('currentip').innerHTML = splitarray[0];
	document.getElementById('currentmask').innerHTML = splitarray[1];
	document.getElementById('currentgate').innerHTML = splitarray[2];
	document.getElementById('currentname').innerHTML = splitarray[3];
	document.getElementById('currentmac').innerHTML = splitarray[4];
	}
    else if (sequencendx==4)
	{
	// PL to config: pressure limits
	badresp = parsepres(str1);  // puts in place
	}
    else if (sequencendx==5)
	{
	// IX to config: IP info
	badresp = parseip(str1);  // puts in place
	}
    else if (sequencendx==6)
	{
	// SX to config: SNMP info
	badresp = parsesnmp(str1);  // puts in place
	}
    else if (sequencendx==7)
	{
	// CX to config: SNMP communities
	badresp = parsecmun(str1);  // puts in place
	}
    else if (sequencendx==8)
	{
	// MX to config: serial params
	badresp = parsecomm(str1);  // puts in place
	}
    else if (sequencendx==9)
	{
	// RX to config: duty cycle, short cycle param
	badresp = parsedc(str1);  // puts in place
	}
    else if (sequencendx==10)
	{
	// RM to config: bit-mapped alarm configuration
	badresp = parselrms(str1);  // puts in place
	}
    else
	{
	sysalert("Error: sequencendx=" + sequencendx);
	sequencendx=10;  // abort sequence
	}
    if (badresp) doalert("Bad response: [" + str0 + "]");
    if (sequencendx==10)
	{
	// end of sequencer
	sequencendx=0;
	config_endinit();
	}
    else
	{
	sequencendx++;
	dosequencer();
	}
    }
  }

function config_endinit()
  {
  // get here when initialization is done
  var elt;
  disorenableall(0);  // user input allowed
  }



function fetchit(param)
  {
  // send to config.cgi - retrieve info from netcom and put in fields
  if ( (cxcfgin.readyState==4) || (cxcfgin.readyState==0) )
    {
    cxcfgin.open("POST", "config.cgi", true);
    cxcfgin.onreadystatechange = cfginreturn;
    cxcfgin.send(param);
    timeoutidcfgin = window.setTimeout("timeoutcfgin();", 1000);
    }
  else alert("Busy - try again");
  }



function timeoutcfgin()
  {
  doalert("Timed out - retry");
  cxcfgin.abort();
  }




function cfginreturn()
  {
  var str0;
  var keypos;
  var prestr;
  var str1;
  var badresp;
  // check to see if finished
  if ( (cxcfgin.readyState==4) && (cxcfgin.status==200) )
    {
    // get it! process
    window.clearTimeout(timeoutidcfgin);
    str0 = cxcfgin.responseText;
    keypos = findkeypos(str0);
    if ( (keypos!=2) || (str0.charAt(keypos) != ":") )
      {
      // error return - should be impossible
      doalert("Unexpected response [" + str0 + "]");
      return;
      }
    str1 = str0.slice(keypos+1);
    prestr=str0.slice(0,2);  // tells which command it was
    if (prestr == "IX")  badresp = parseip(str1);
    else if (prestr =="SX") badresp = parsesnmp(str1);
    else if (prestr =="CX") badresp = parsecmun(str1);
    else if (prestr =="PL") badresp = parsepres(str1);
    else if (prestr =="MX") badresp = parsecomm(str1);
    else if (prestr =="RX") badresp = parsedc(str1);
    else if (prestr =="RM") badresp = parselrms(str1);
    else badresp=1;
    if (badresp) doalert("Unexpected response [" + str0 + "]");
    }
  }



function setdhcp(isdhcp)
   {
   // enable or disable the fixed ip fields:
   // dhcp means disabled
   document.ipconfig.ip.disabled = isdhcp;
   document.ipconfig.mask.disabled = isdhcp;
   document.ipconfig.gate.disabled = isdhcp;
   document.ipconfig.mane.disabled = false;  // name always ok
   }


function parseip(instr)
  {
  // return 1 if error
  var splitarray;
  splitarray = instr.split(";");
  // first char is D or F, determines form of response
  if (instr.charAt(0)=="F")
	{
	// F: fixed fields included
	if (splitarray.length != 6) return 1;
	document.ipconfig.DHCP[0].checked=0;
	document.ipconfig.DHCP[1].checked=1;
	setdhcp(0);  // fixed fields enabled
	// use the real data
	document.ipconfig.ip.value = splitarray[1];
	document.ipconfig.mask.value = splitarray[2];
	document.ipconfig.gate.value = splitarray[3];
	document.ipconfig.mane.value = splitarray[4];
	return 0;
	}
  else if (instr.charAt(0)=='D')
	{
	// DHCP only
	if (splitarray.length != 3) return 1;
	document.ipconfig.DHCP[0].checked=1;
	document.ipconfig.DHCP[1].checked=0;
	setdhcp(1);  // fixed fields disabled
	// dhcp: kill the fixed fields; no incoming data
	document.ipconfig.ip.value = "";
	document.ipconfig.mask.value = "";
	document.ipconfig.gate.value = "";
	document.ipconfig.mane.value = splitarray[1];
	return 0;
	}
  else return 1;
    }






function parsesnmp(instr)
  {
  // return 1 if bad
  var splitarray;
  splitarray = instr.split(";");
  if (splitarray.length != 4) return 1;
    // insert into form
  document.snmpparams.sn.value = splitarray[0];
  document.snmpparams.sl.value = splitarray[1];
  document.snmpparams.sc.value = splitarray[2];
  return 0;
  }

function parsecmun(instr)
  {
  // return 1 if bad
  var splitarray;
  splitarray = instr.split(";");
  if (splitarray.length != 3) return 1;
  // insert into form
  document.cmunparams.rc.value = splitarray[0];
  document.cmunparams.wc.value = splitarray[1];
  return 0;
  }

function parsepres(instr)
  {
  // return 1 if bad
  var splitarray;
  var ismetric;
  splitarray = instr.split(";");
  if (splitarray.length != 6) return 1;
  // first fields is now E or M:
  if (splitarray[0]=="E")
	{
	document.preslimits.units.selectedIndex=0;
	document.preslimits.smallsys.checked=0;
	ismetric=0;
	}
   else if (splitarray[0]=="e")
	{
	document.preslimits.units.selectedIndex=0;
	document.preslimits.smallsys.checked=1;
	ismetric=0;
	}
  else if (splitarray[0]=="M")
	{
	document.preslimits.units.selectedIndex=1;
	document.preslimits.smallsys.checked=0;
	ismetric=1;
	}
  else if (splitarray[0]=="m")
	{
	document.preslimits.units.selectedIndex=1;
	document.preslimits.smallsys.checked=1;
	ismetric=1;
	}
  else return 1;
  // insert into form: if PSI divide by 100; else is just whole mbars
  if (ismetric)
      {
      document.preslimits.la.value = splitarray[1];
      document.preslimits.ll.value = splitarray[2];
      document.preslimits.ul.value = splitarray[3];
      document.preslimits.ua.value = splitarray[4];
      }
  else
      {
      document.preslimits.la.value = splitarray[1] / 100 ;
      document.preslimits.ll.value = splitarray[2] / 100 ;
      document.preslimits.ul.value = splitarray[3] / 100 ;
      document.preslimits.ua.value = splitarray[4] / 100 ;
      }
  return 0;
  }


function parsecomm(instr)
  {
  // return 1 if bad
  var x;
  var y;
  var ndx;
  var i;
  var ok;
  if (instr.length <10) return 1;
  ok=1;  // set to 0 if error
  x=instr.charAt(0);  // RS422A: XSAM
  ndx="XSAM".indexOf(x);
  if (ndx==-1) ok=0;
  else document.commconfig.type422a.selectedIndex=ndx;
  x=instr.charAt(1);  // F or S
  if (x=='F') document.commconfig.slow422a.checked=0;
  else if (x=='S') document.commconfig.slow422a.checked=1;
  else ok=0;
  x=instr.charAt(2);  // + or -
  if (x=='+') document.commconfig.pullups422a.checked=1;
  else if (x=='-') document.commconfig.pullups422a.checked=0;
  else ok=0;
  x=instr.charAt(3);  // RS422B: XSAM
  ndx="XSAM".indexOf(x);
  if (ndx==-1) ok=0;
  else document.commconfig.type422b.selectedIndex=ndx;
  x=instr.charAt(4);  // F or S
  if (x=='F') document.commconfig.slow422b.checked=0;
  else if (x=='S') document.commconfig.slow422b.checked=1;
  else ok=0;
  x=instr.charAt(5);  // RS232: XSAM
  ndx="XSAM".indexOf(x);
  if (ndx==-1) ok=0;
  else document.commconfig.type232.selectedIndex=ndx;
  x=instr.charAt(6);  // F or S
  if (x=='F') document.commconfig.slow232.checked=0;
  else if (x=='S') document.commconfig.slow232.checked=1;
  else ok=0;

  x=instr.charCodeAt(7);  // SA address, as number
  document.commconfig.saaddress.value = x.toString(16);  // hex

  x=instr.charCodeAt(8);  // as number: metric/range/delims
  x -= 0x41;
  // delims: low 2 bits
  // bit 1 is CR, bit 0 is LF
  // we are not supporting neither in this web page: call it both if see it
  if ( (x&3)==2) document.commconfig.delim.selectedIndex=0;  // cr
  else if ( (x&3)==1) document.commconfig.delim.selectedIndex=1;  // lf
  else document.commconfig.delim.selectedIndex=2;  // crlf
  // bit 5 is metric
  document.commconfig.metric.checked = ( (x&0x20) != 0);
  // bits 3,2 is range: 0,1,2
  ndx = (x>>2) & 3;
  if (ndx==3) ok=0;
  else
    {
    for (i=0; i<2; i++)
	document.commconfig.range[i].checked = (i==ndx);
    }
  x=instr.charAt(9);  // master type
  if (x=='X')
	{
	document.commconfig.target[0].checked=1;
	document.commconfig.target[1].checked=0;
	document.commconfig.target[2].checked=0;
	document.commconfig.target[3].checked=0;
	document.commconfig.sertarget.value="";
	document.commconfig.ip.value="";
	document.commconfig.netname.value="";
	}
  else if ( (x=='A') || (x=='B') || (x=='C') )
	{
	document.commconfig.target[0].checked=0;
	document.commconfig.target[1].checked=1;
	document.commconfig.target[2].checked=0;
	document.commconfig.target[3].checked=0;
	document.commconfig.ip.value="";
	document.commconfig.netname.value="";
	y=instr.charCodeAt(10);  // SA target address, as number
	document.commconfig.sertarget.value = y.toString(16);  // hex
	}
  else if (x=='F')
	{
	// fixed IP
	document.commconfig.target[0].checked=0;
	document.commconfig.target[1].checked=0;
	document.commconfig.target[2].checked=1;
	document.commconfig.target[3].checked=0;
	document.commconfig.netname.value="";
	document.commconfig.sertarget.value="";
	document.commconfig.ip.value=instr.substring(10);
	}
  else if (x=='N')
	{
	// named
	document.commconfig.target[0].checked=0;
	document.commconfig.target[1].checked=0;
	document.commconfig.target[2].checked=0;
	document.commconfig.target[3].checked=1;
	document.commconfig.sertarget.value="";
	document.commconfig.ip.value="";
	document.commconfig.netname.value=instr.substring(10);
	}
  else ok=0;
  if (ok) return 0; else return 1;
  }


function parsedc(instr)
  {
  // return 1 if bad
  var splitarray;
  var dcthresh;
  var scp;
  splitarray = instr.split(";");
  if (splitarray.length != 3) return 1;
  dcthresh = parseInt(splitarray[0],10);
  // should never be out of range, but doesn't hurt to check
  // if it is, just correct
  if (dcthresh<0) dcthresh=0;
  if (dcthresh>100) dcthresh=100;
  // insert dcthreshold into form and save
  document.getElementById("dcthspan").value = dcthresh.toString(10);


  scp = parseInt(splitarray[1],10);
  // should never be out of range, but doesn't hurt to check
  if (scp<1) scp=1;
  if (scp>60) scp=60;
  // insert  into form and save
  document.getElementById("scpspan").value = scp.toString(10);
  return 0;
  }


function parselrms(instr)
  {
  // return 1 if bad
  // alarms are 1-21 = numalarms; corresponding to that bit
  // id of the checkbox uses the bit number: 1-21
  var splitarray;
  var val1;
  var val2;
  var val3;
  var ndx;
  var eltname;
  var elt;
  var value;
  var mask;
  splitarray = instr.split(";");
  if (splitarray.length != 4) return 1;
  // now decode: 3 hex numbers, 32 bits each
  val1 = parseInt(splitarray[0],16);
  val2 = parseInt(splitarray[1],16);
  val3 = parseInt(splitarray[2],16);
  // use vals to check/uncheck boxes
  for (ndx=1,mask=2; ndx<=numalarms; ndx++, mask<<=1)
     {
     ndxstring = ndx.toString(10);
     if ( (ndx!=6) && (ndx!=13) )
	{
	// those are the unused ones: always leave unchecked
	eltname = "LX" + ndxstring;
	elt = document.getElementById(eltname);
	if (mask&val1) elt.checked = 1; else elt.checked=0;
	eltname = "LY" + ndxstring;
	elt = document.getElementById(eltname);
	if (mask&val2) elt.checked = 1; else elt.checked=0;
	eltname = "LZ" + ndxstring;
	elt = document.getElementById(eltname);
	if (mask&val3) elt.checked = 1; else elt.checked=0;
	}
     }
  }


function tointeger(fval)
  {
  return parseInt(fval.toFixed(), 10);
  }



function changeunits()
  {
  // called when they change from metric to english or vice versa
  var fval;  // floating point value, from field
  var ival;  // integer value, for conversion
  var mult;
  var conv;
  if (document.preslimits.units.selectedIndex==1)  // new value: PSI to mbar
     {mult=1.0; conv=68.9476;}
  else 
     {mult=100.0; conv = 1.0/68.9476;}
  fval = parseFloat(document.preslimits.la.value,10);
  if (isFinite(fval))
    {
    fval *= conv;
    ival = tointeger(fval*mult);
    fval = ival;
    fval = fval / mult;
    document.preslimits.la.value = fval;
    }
  fval = parseFloat(document.preslimits.ll.value,10);
  if (isFinite(fval))
    {
    fval *= conv;
    ival = tointeger(fval*mult);
    fval = ival;
    fval = fval / mult;
    document.preslimits.ll.value = fval;
    }
  fval = parseFloat(document.preslimits.ua.value,10);
  if (isFinite(fval))
    {
    fval *= conv;
    ival = tointeger(fval*mult);
    fval = ival;
    fval = fval / mult;
    document.preslimits.ua.value = fval;
    }
  fval = parseFloat(document.preslimits.ul.value,10);
  if (isFinite(fval))
    {
    fval *= conv;
    ival = tointeger(fval*mult);
    fval = ival;
    fval = fval / mult;
    document.preslimits.ul.value = fval;
    }
  }

function clearresult(name)
  {
  elt = document.getElementById(name+"result");
  elt.style.display="none";
  }


function submitit(elt,param)
  {
  // submit to config.cgi - triggered by user
  // put error message in the right spot: given by elt
  if ( (cxcfgout.readyState==4) || (cxcfgout.readyState==0) )
     {
     // ok to do it: set up as POST request
     cxcfgout.open("POST", "config.cgi", true);  // asynchronous, POST
     // set up function to be called when state changes
     cxcfgout.onreadystatechange = submititreturn;
     cxcfgout.send(param);
     timeoutidcfgout = window.setTimeout("timeoutcfgout(elt);", 1000);
     }
  else resultalert(elt, "Busy - try again");
  }

function timeoutcfgout(key)
  {
  cxcfgout.abort();
  resultalert(key, "Timed out - retry");
  }


function dosubmitip()
  {
  // note: seems it is not ok to use same string for function and name/id
  var param;
  var xi, xm, xg, xn, xt;
  var isok;
  var key;
  key = "ip";
  // first put together the parameter string
  // make sure no element has a semicolon in it
  isok=1;
  if (document.ipconfig.DHCP[0].checked) xt="D";
  else if (document.ipconfig.DHCP[1].checked) xt="F";
  else
    {
    resultalert(key, "Select DCHP or Fixed");
    return;
    }
  xi = document.ipconfig.ip.value;
  if (xi.indexOf(";") != -1) isok=0;
  xm = document.ipconfig.mask.value;
  if (xm.indexOf(";") != -1) isok=0;
  xg = document.ipconfig.gate.value;
  if (xg.indexOf(";") != -1) isok=0;
  xn = document.ipconfig.mane.value;
  if (xn.indexOf(";") != -1) isok=0;
  if (!isok)
    {
    resultalert(key, "No semicolons, please");
    return;
    }
  if (xt=="F")
    param = "I=" + xt + ";"  + xi + ";" + xm + ";" + xg + ";" + xn + ";" ;
  else
    param = "I=" + xt + ";"  + xn + ";" ;
  submitit(key,param);
  }
  

function dosubmitsnmp()
{
  var param;
  var xn, xl, xc;
  var isok;
  var key;
  key = "snmp"
  // first put together the parameter string
  // make sure no element has a semicolon in it
  isok=1;
  xn = document.snmpparams.sn.value;
  if (xn.indexOf(";") != -1) isok=0;
  xl = document.snmpparams.sl.value;
  if (xl.indexOf(";") != -1) isok=0;
  xc = document.snmpparams.sc.value;
  if (xc.indexOf(";") != -1) isok=0;
  if (!isok)
    {
    resultalert(key, "No semicolons, please");
    return;
    }
  param = "S=" + xn + ";"  + xl + ";" + xc + ";"  ;
  submitit(key,param);
  }


function dosubmitcmun()
  {
  var param;
  var xr, xw;
  var isok;
  var key;
  key = "cmun";
  // first put together the parameter string
  // make sure no element has a semicolon in it
  isok=1;
  xr = document.cmunparams.rc.value;
  if (xr.indexOf(";") != -1) isok=0;
  xw = document.cmunparams.wc.value;
  if (xw.indexOf(";") != -1) isok=0;
  if (!isok)
    {
    resultalert(key, "No semicolons, please");
    return;
    }
  param = "C=" + xr + ";"  + xw + ";"  ;
  submitit(key,param);
  }


function dosubmitpres()
  {
  // either English or metric, depending on form
  var param;
  var fltval;  // from form: floating point, in PSI
  var ila, ill, iul, iua;  // convert to integers
  var mx;  // M or E
  var isok;
  var ismetric;
  var mult;
  var maxval;
  var key;
  key = "pres";
  if (document.preslimits.units.selectedIndex==0)
    {
    // English units
    mult=100.0;   // multiply number in box by 100 to convert to integer
    ismetric=0;
    maxval=10.0;
    if (document.preslimits.smallsys.checked) mx="e"; else mx="E";
    }
  else if (document.preslimits.units.selectedIndex==1)
    {
    // metric units
    mult=1.0;   // number in box in mbars, which is what we submit
    ismetric=1;
    maxval=689.4;  // 10 psi, in mbar
    mx="M";
    if (document.preslimits.smallsys.checked) mx="m"; else mx="M";
    }
  else
    {
    resultalert(key,"Must select units");
    return;
    }
  // first put together the parameter string
  if (ismetric) mult=1.0; else mult=100.0;  // multiply by this to get int.
  isok=1;
  if (isok)
    {
    fltval = parseFloat(document.preslimits.la.value,10);
    if (isNaN(fltval)) isok=0;
    else if (fltval<=0.0) isok=0;
    else if (fltval>maxval) isok=0;
    else ila = tointeger(fltval*mult);
    }
  if (isok)
    {
    fltval = parseFloat(document.preslimits.ll.value,10);
    if (isNaN(fltval)) isok=0;
    else if (fltval<=0.0) isok=0;
    else if (fltval>maxval) isok=0;
    else ill = tointeger(fltval*mult);
    }
  if (isok)
    {
    fltval = parseFloat(document.preslimits.ul.value,10);
    if (isNaN(fltval)) isok=0;
    else if (fltval<=0.0) isok=0;
    else if (fltval>maxval) isok=0;
    else iul = tointeger(fltval*mult);
    }
  if (isok)
    {
    fltval = parseFloat(document.preslimits.ua.value,10);
    if (isNaN(fltval)) isok=0;
    else if (fltval<=0.0) isok=0;
    else if (fltval>maxval) isok=0;
    else iua = tointeger(fltval*mult);
    }
  if (!isok)
    {
    resultalert(key, "Error in parameters");
    return;
    }
  param="L=" + mx + ";" + ila + ";" + ill + ";" + iul + ";" + iua + ";" ;
  submitit(key,param);
  }


function dosubmitcomm()
  {
  var param;  // string to submit: only doing some fields now
  var x;  // sub character
  var ndx;
  var ok;
  var xstr;  // from text box
  var masterchar;  // for serial
  var y;
  var z;
  ok=1;
  var key;
  key = "comm";
  param = "M=";
  masterchar="?";  // won't be used unless changes
  ndx = document.commconfig.type422a.selectedIndex;
  if (ndx==-1)  ok=0;
  else param =  param + "XSAM".charAt(ndx);
  if (ndx==3) masterchar="A";
  if (document.commconfig.slow422a.checked) x="S"; else x="F";
  param = param + x;
  if (document.commconfig.pullups422a.checked) x="+"; else x="-";
  param = param + x;

  ndx = document.commconfig.type422b.selectedIndex;
  if (ndx==-1)  ok=0;
  else param =  param + "XSAM".charAt(ndx);
  if (ndx==3) masterchar="B";
  if (document.commconfig.slow422b.checked) x="S"; else x="F";
  param = param + x;

  ndx = document.commconfig.type232.selectedIndex;
  if (ndx==-1)  ok=0;
  else param =  param + "XSAM".charAt(ndx);
  if (ndx==3) masterchar="C";
  if (document.commconfig.slow232.checked) x="S"; else x="F";
  param = param + x;

  x=document.commconfig.saaddress.value;
  x=parseInt(x,16);  // is in hex!
  if (isNaN(x)) ok=0;
  else   param = param + String.fromCharCode(x);

  x=0x41;
  if (document.commconfig.delim.selectedIndex == 0) x+=2;  // cr
  else if (document.commconfig.delim.selectedIndex == 1) x+=1;  // lf
  else x+=3;  // crlf
  if (document.commconfig.range[1].checked) x+=4;
  if (document.commconfig.range[2].checked) x+=8;
  if (document.commconfig.metric.checked) x+=0x20;
  param = param + String.fromCharCode(x);


  if (document.commconfig.target[1].checked)
    {
    // want serial slave
    y=document.commconfig.sertarget.value;
    z=parseInt(y,16);  // is in hex
    // masterchar has the right letter for which it is
    if (isNaN(y)) ok=0;
    else if (masterchar=="?") ok=0;
    else   param = param + masterchar+ String.fromCharCode(z) + ";";
   }
  else if (document.commconfig.target[2].checked)
    {
    // asking for fixed IP
    // make sure ok - just no semicolon allowed, or gets confused
    xstr =  document.commconfig.ip.value;
    if (xstr.indexOf(";") != -1)
	{
	resultalert(key, "No semicolons please");
	return;
	}
    param = param + "F" + xstr + ";" ;
    }
  else if (document.commconfig.target[3].checked)
    {
    // asking for network name
    // make sure ok - just no semicolon allowed, or gets confused
    xstr =  document.commconfig.netname.value;
    if (xstr.indexOf(";") != -1)
	{
	resultalert(key, "No semicolons please");
	return;
	}
    param = param + "N" + xstr + ";" ;
    }
  else param = param+"X;"
  if (!ok)
    {
    resultalert(key, "Invalid configuration");
    return;
    }
  // now parameter ready: send it
  submitit(key,param);
  }


function dosubmitdc()
  {
  var isok;
  var fltval;
  var dcthresh;
  var scparam;
  var param;
  var key;
  key = "dc";
  isok=1;
  // dcthresh: 0 to 100 ok
  fltval = parseFloat(document.getElementById("dcthspan").value, 10);
  if (isNaN(fltval)) isok=0;
  else if (fltval<0.0) isok=0;
  else if (fltval>100.0) isok=0;
  else dcthresh = tointeger(fltval);
  if (!isok)
    {
    resultalert(key, "Duty cycle threshold: 0 to 100");
    return;
    }
  // scparam: 1-60
  fltval = parseFloat(document.getElementById("scpspan").value, 10);
  if (isNaN(fltval)) isok=0;
  else if (fltval<1.0) isok=0;
  else if (fltval>60.0) isok=0;
  else scparam = tointeger(fltval);
  if (!isok)
    {
    resultalert(key, "Short Cycle Limit: 1 to 60");
    return;
    }
  // here, ok: submit it
  param = "X=" + dcthresh.toString(10) + ";" + scparam.toString(10) + ";" ;
  submitit(key,param);
  }


function dosubmitlrms()
  {
  var param;
  var val1;
  var val2;
  var val3;
  var ndx;
  var mask;
  var eltname;
  var elt;
  var key;
  key = "lrms";
  // first put together the parameter string
  // need to get the three masks
  val1=0;
  val2=0;
  val3=0;
  // put together the checks to make the values to submit
  for (ndx=1,mask=2; ndx<=numalarms; ndx++, mask<<=1)
     {
     ndxstring = ndx.toString(10);
     if ( (ndx!=6) && (ndx!=13) )
	{
	// those are the unused ones: always leave unchecked
	eltname = "LX" + ndxstring;
	elt = document.getElementById(eltname);
	if (elt.checked) val1 |= mask;
	eltname = "LY" + ndxstring;
	elt = document.getElementById(eltname);
	if (elt.checked) val2 |= mask;
	eltname = "LZ" + ndxstring;
	elt = document.getElementById(eltname);
	if (elt.checked) val3 |= mask;
	}
     }
  // now can create the parameter string:
  param = "R=" + val1.toString(16) + ";" + val2.toString(16) + ";" +
                val3.toString(16) + ";" ;
  submitit(key,param);
  }



function resultalert(key, msg)
  {
  // key is the "id"
  // use the red block, and insert msg
  var elt;
  var textelt;
  elt = document.getElementById(key + "result");
  textelt = document.getElementById(key + "restext");
  textelt.innerHTML = msg;
  textelt.style.display = "block";
  elt.className = "badresponse";
  elt.style.display = "block";
  }

function submititreturn()
  {
  // getting response from config.cgi to submit action
  var key;
  var elt;
  var textelt;
  var str0;
  var keypos;
  var prestr;
  var str1;
  var resptype;  // 0=normal, 1=rebooting, 2=error
  // check to see if finished
  if ( (cxcfgout.readyState==4) && (cxcfgout.status==200) )
    {
    // get it! process
    window.clearTimeout(timeoutidcfgout);
    str0 = cxcfgout.responseText;
    keypos = findkeypos(str0);
    if (keypos!=2)
      {
      // error return - should be impossible
      // don't know where it came from, so can't put in right place
      doalert("Unexpected response [" + str0 + "]");
      return;
      }
    str1 = str0.slice(3);
    prestr=str0.slice(0,2);  // tells which command it was
    if (prestr == "I=")     key = "ip";
    else if (prestr =="S=") key = "snmp";
    else if (prestr =="C=") key = "cmun";
    else if (prestr =="L=") key = "pres";
    else if (prestr =="M=") key = "comm";
    else if (prestr =="X=") key = "dc";
    else if (prestr =="R=") key = "lrms";
    else
      {
      // error return - should be impossible
      // don't know where it came from, so can't put in right place
      doalert("Unexpected response [" + str0 + "]");
      return;
      }
    elt = document.getElementById(key + "result");
    textelt = document.getElementById(key + "restext");
    if (str0.charAt(2) == '_') resptype=0;
    else if (str0.charAt(2) == '^') resptype=1;
    else if (str0.charAt(2) == '!') resptype=2;
    else
      {
      // error return - should be impossible
      resultalert(elt, "Unexpected response [" + str0 + "]");
      return;
      }
    textelt.innerHTML = str1;
    textelt.style.display = "block";
    if (resptype==0) elt.className = "goodresponse";
    else if (resptype==1) elt.className = "warnresponse";
    else elt.className = "badresponse";
    elt.style.display = "block";
    }
  }

