// ncstatus.js: Javascript for the status page of ADH NETCOM



// XMLHttpRequest objects
var sxinit = false;  // initial sequencer
var sxaction = false; // action routine: no data returned
var sxstatus = false; // get data from status

// get the xmlHttp request object - browser dependent
if (window.XMLHttpRequest)
  {
  sxinit = new XMLHttpRequest();
  sxaction = new XMLHttpRequest();
  sxstatus = new XMLHttpRequest();
  }
else if (window.ActiveObject)
  {
  sxinit = new ActiveXObject("Microsoft.XMLHTTP");
  sxaction = new ActiveXObject("Microsoft.XMLHTTP");
  sxstatus = new ActiveXObject("Microsoft.XMLHTTP");
  }
else
  {
  alert("Browser does not support xmlHttpRequest object - need to upgrade");
  }

// timeoutid's : one for each xmlhHTTP object
var timeoutidinit;
var timeoutidact;
var timeoutidstat;
// and one for refresh timer - when to do another reading
var refreshtimerid;

var numtimeouts;  // for sequencer or auto: error timeouts only
var refreshtime;  // how often to refresh status: 0 means never

var units="S"; // "S" for default, or "E" or "M" for Engish or Metric

var sequencecount = 5;
var sequencelist = new Array(5);
var sequencendx;
// string tells what to do: start with C or S
sequencelist[0] = "CVA";  // main firmware
sequencelist[1] = "CVR";  // Rabbit firmware
sequencelist[2] = "SI";    // serial number(s)
sequencelist[3] = "CIC";  // current IP etc.
sequencelist[4] = "S" + units;  // status - default units to start anyway

// list of alarms:
var numalarms = 22;
var alarmlist=new Array(22);
alarmlist[0] =  "1:  low pressure";
alarmlist[1] =  "2:  high pressure";
alarmlist[2] =  "3:  leaky (high duty cycle)";
alarmlist[3] =  "4:  too hot";
alarmlist[4] =  "5:  too cold";
alarmlist[5] =  "6:  low voltage (system error)";
alarmlist[6] =  "7:  canister 1 won't heat";
alarmlist[7] =  "8:  canister 1 won't cool";
alarmlist[8] =  "9:  canister 2 won't heat";
alarmlist[9] =  "10: canister 2 won't cool";
alarmlist[10] = "11: very leaky (shut down)";
alarmlist[11] = "12: dew point alarm";
alarmlist[12] = "13: compressor timeout (system error)";
alarmlist[13] = "14: comm error";
alarmlist[14] = "15: canister 1 thermistor bad";
alarmlist[15] = "16: canister 2 thermistor bad";
alarmlist[16] = "17: ambient thermistor bad";
alarmlist[17] = "18: overpressure";
alarmlist[18] = "19: calibration factors corrupted";
alarmlist[19] = "20: pressure limits corrupted";
alarmlist[20] = "21: short duty cycle"
alarmlist[21] = "22: abandoned pumping"


function doalert(str)
// really want to put in alert field - later
  {
  alert(str);
  }

function sysalert(str)
// should be impossible; error in Javascript
  {
  alert("SYSTEM ERROR:\n" + str);
  }


function disorenableall(dis)
  {
  // enable or disable all the user buttons - for initializatin
  document.getElementById("standby").disabled=dis;
  document.getElementById("online").disabled=dis;
  document.getElementById("getstatus").disabled=dis;
  }


function findkeypos(str)
  {
  // return the position of the "key" in str
  // key can be ! or _ or : or ^
  // has to be 0, 1, or 2: else no key, return0
  var pos;
  pos = str.search(/[\!\:\_\^]/);
  if (pos==-1) pos=0;
  if (pos>2) pos=0;
  return pos;
  }


function status_initialize()
  {
  var but;
  // set auto refresh to 3 seconds
  refreshtime=3000;
  but=document.refreshform.rgroup;
  but[0].checked=0;  // .5 sec
  but[1].checked=0;  // 1 sec
  but[2].checked=1;  // 3 sec
  but[3].checked=0;  // 10 sec
  but[4].checked=0;  // off
  // start sequencer
//  document.getElementById("alertspan").innerHTML = "initializing...";
  sequencendx=0;
  numtimeouts=0;
  disorenableall(1);  // no user input allowed
  dosequencer();  // will enable buttons and start refresh when done
  }


function dosequencer()
  {
  var url;
  var ajaxmsg;
  var x;
  x=sequencelist[sequencendx].charAt(0);
  if (x=='C') url="config.cgi";
  else if (x=='S') url="status.cgi";
  else
    {
    doalert("Bad sequencer element - aborting");
    return;
    }
  ajaxmsg = sequencelist[sequencendx].slice(1);  // start after first char
  if ( (sxinit.readyState==4) || (sxinit.readyState==0) )
    {
    sxinit.open("POST", url, true);
    sxinit.onreadystatechange = sxinitreturn;
    sxinit.send(ajaxmsg);
    timeoutidinit = window.setTimeout("timeoutrtninit();", 1000);
    }
  else
    {
    doalert("Sequencer stuck - aborting");
    return;
    }
  }


function timeoutrtninit()
  {
  // get here if sequencer times out - allow 5 before alerting
  // no - not alerting at all now; but might put back in
  numtimeouts++;
// if (numtimeouts>=5)
//  doalert("Warning: initializer has failed " + numtimeouts + " times so far");
  dosequencer();  // continue to try
  }

function sxinitreturn()
  {
  var str0;
  var keypos;
  var str1;
  var splitstr;
  // check to see if finished
  if ( (sxinit.readyState==4) && (sxinit.status==200) )
    {
    // get it! process
    window.clearTimeout(timeoutidinit);
    numtimeouts=0;
    str0 = sxinit.responseText;
    keypos = findkeypos(str0);
    if (str0.charAt(keypos) != ":")
      {
      // error return - should be impossible
      doalert("Unexpected response [" + str0 + "]");
      dosequencer();  // keep retrying
      return;
      }
    // here, is ok
    // we know where it came from: don't need to parse
    str1 = str0.slice(keypos+1);
    badresp=0;  // default
    if (sequencendx==0)
	{
	// VA to config: get main firmware
	splitarray = str1.split("$");
	if (splitarray.length!=4) badresp=1;
	document.getElementById("mainfw").innerHTML = splitarray[0];
	}
    else if (sequencendx==1)
	{
	// VR to config: get comm firmware
	document.getElementById("commfw").innerHTML = str1;
	}
    else if (sequencendx==2)
	{
	// I to status: get serial numbers
	splitarray = str1.split(";");
	if (splitarray.length!=3) badresp=1;
	document.getElementById("sernum").innerHTML = splitarray[2];
	}
    else if (sequencendx==3)
	{
	// IC to config: current IP etc.
	splitarray = str1.split(";");
	if (splitarray.length!=6) badresp=1;
	document.getElementById('currentip').innerHTML = splitarray[0];
	document.getElementById('currentmask').innerHTML = splitarray[1];
	document.getElementById('currentgate').innerHTML = splitarray[2];
	document.getElementById('currentname').innerHTML = splitarray[3];
	document.getElementById('currentmac').innerHTML = splitarray[4];
	}
    else if (sequencendx==4)
	{
	// S to status: main status info
	badresp = parsestatus(str1);  // puts in place
	}
    else
	{
	sysalert("Error: sequencendx=" + sequencendx);
	sequencendx=4;  // abort sequence
	}
    if (badresp) doalert("Bad response: [" + str0 + "]");
    if (sequencendx==4)
	{
	// end of sequencer
	sequencendx=0;
	status_endinit();
	}
    else
	{
	sequencendx++;
	dosequencer();
	}
    }
  }

function status_endinit()
  {
  // get here when initialization is done
  var elt;
  disorenableall(0);  // user input allowed
  setrefresh(refreshtime);
  }


function setrefresh(param)
  {
  refreshtime = param;
  window.clearTimeout(refreshtimerid);
  if (refreshtime)
	{
	document.getElementById("getstatus").disabled=true;
        refreshtimerid=window.setTimeout("refreshrtn();", refreshtime);
	}
  else document.getElementById("getstatus").disabled=false;
  }


function refreshrtn()
  {
  // gets called when refresh timer runs out: just get info
  getstatus();
  }



function condalert(str)
{
// do NOT want to alert timeouts etc when doing automatics
// since nobody is there maybe to clear it!
if (refreshtime==0) alert(str);
}

function condgetstatus()
{
// do not do it if refresh is off
if (refreshtime==0) getstatus();
}

function getstatus()
  {
  // get status info from ADH, display on screen when returns
  if ( (sxstatus.readyState==4) || (sxstatus.readyState==0) )
     {
     // ok to do it: set up as POST request
     sxstatus.open("POST", "status.cgi", true);  // asynchronous, POST
     // set up function to be called when state changes
     sxstatus.onreadystatechange = getstatusreturn;
     sxstatus.send(units);
     timeoutidstat = window.setTimeout("timeoutrtnstat();", 1000);
     }
  else condalert("Busy");
  }



function timeoutrtnstat()
  {
  // gets called if the xmlhttp request times out
  // clear it and reenable the window; also alert
  sxstatus.abort();
  condalert("Request timed out");
// and restart timer
  window.clearTimeout(refreshtimerid);
  if (refreshtime)
       refreshtimerid=window.setTimeout("refreshrtn();", refreshtime);
  }






function getstatusreturn()
  {
  var instr0;
  var instr1;
  var splitarray;   // 6 fields,with terminating semicolon
  var keypos;
  var badresp;
  // check to see if finished
  if ((sxstatus.readyState==4) && (sxstatus.status==200) )  
    {
    window.clearTimeout(timeoutidstat);
    window.clearTimeout(refreshtimerid);
    if (refreshtime)
       refreshtimerid=window.setTimeout("refreshrtn();", refreshtime);
    // write values into form, IF valid
    instr0 = sxstatus.responseText;
    keypos = findkeypos(instr0);
    instr1 = instr0.slice(keypos+1);
    badresp = parsestatus(instr1);
    if (badresp) doalert("Bad response: [" + str0 + "]");
    }
  }


function parsestatus(instr)
  {
  // parse status return message; return 1 if bad
  // put results into the appropriate fields
  var splitarray;
  var ontime;
  var tottime;
  var badresp
  badresp=0;
  splitarray = instr.split(";");
  if (splitarray.length != 8) return 1;
  // process info
  document.getElementById('pressure').innerHTML = splitarray[0];
  ontime=splitarray[1];
  tottime=splitarray[2];
  if (tottime==0.0)
	{
	document.getElementById('dutycycle').innerHTML = "---"
	document.getElementById('cycleontime').innerHTML = "---"
	document.getElementById('cycletottime').innerHTML = "---"
	}
  else
	{
	dc = 100.0 * ontime / tottime;
	document.getElementById('dutycycle').innerHTML = dc.toFixed(1) + "%";
	document.getElementById('cycleontime').innerHTML = ontime
	document.getElementById('cycletottime').innerHTML = tottime;
	}
  document.getElementById('temperature').innerHTML = splitarray[4];
  if (processstates(splitarray[3])) badresp=1;
  processalarms(splitarray[5]);
  document.getElementById('complife').innerHTML = splitarray[6];
  return badresp;
  }

function processstates(str)
  {
  // return 1 if error
  var x;
  var y;
// x is char; y is returned value
  if (str.length != 7)
    {
    document.getElementById('superstate').innerHTML = "???";
    document.getElementById('majorstate').innerHTML = "???";
    document.getElementById('env').innerHTML = "???";
    document.getElementById('can1cnt').innerHTML = "???";
    document.getElementById('can1use').innerHTML = "???";
    document.getElementById('can2cnt').innerHTML = "???";
    document.getElementById('can2use').innerHTML = "???";
    return 1;
    }
  x=str.charAt(0);
  if (x=="S") y="Slave";
  else if (x=='M') y="Master";
  else if (x=='N') y="Master Offline";
  else if (x=='D') y="Director";
  else if (x=='E') y="Director Offline";
  else y="???";
  document.getElementById('superstate').innerHTML = y;
  x=str.charAt(1);
  if (x=="N") y="Normal";
  else if (x=="S") y="Standby";
  else if (x=="L") y="Leaky";
  else if (x=="R") y="Remote";
  else y="???";
  document.getElementById('majorstate').innerHTML = y;
  x=str.charAt(2);
  if (x=="N") y="";  // if normal, leave blank
  else if (x=="C") y="Cold";
  else if (x=="H") y="Hot";
  else y="???";
  document.getElementById('env').innerHTML = y;
  x=str.charAt(3);
  if (x=="O") y="Ready";
  else if (x=="F") y="Full";
  else if (x=="U") y="Init.";
  else if (x=="D") y="Dead";
  else y="???";
  document.getElementById('can1cnt').innerHTML = y;
  x=str.charAt(4);
  if (x=="I") y="Idle";
  else if (x=="U") y="In use";
  else if (x=="R") y="Regenerating";
  else y="???";
  document.getElementById('can1use').innerHTML = y;
  x=str.charAt(5);
  if (x=="O") y="Ready";
  else if (x=="F") y="Full";
  else if (x=="U") y="Init.";
  else if (x=="D") y="Dead";
  else y="???";
  document.getElementById('can2cnt').innerHTML = y;
  x=str.charAt(6);
  if (x=="I") y="Idle";
  else if (x=="U") y="In use";
  else if (x=="R") y="Regenerating";
  else y="???";
  document.getElementById('can2use').innerHTML = y;
  return 0;
  }

function processalarms(str)
  {
  var alarmcount;
  var i;
  var res;
  alarmcount=0;
  res="";
  for (i=0; i<str.length; i=i+1)
    {
    if (str.charAt(i) != "-")
	{
	// is an alarm: number is i+1
	alarmcount++;
	if (i<numalarms) res = res + alarmlist[i] + "<br />";
	else res = res + "Alarm # " + (i+1) + "<br />";
	}
    }
  if (alarmcount==0)
     {
     // make it green
     document.getElementById("statusdiv").className = "col_460 noalarms";
     res="No alarms";
     }
  else
     {
     document.getElementById("statusdiv").className = "col_460 alarm";
     // make it red
     }
  document.getElementById('alarms').innerHTML = res;
  }


// routines to go on/ off line
function actionrtn(param)
  {
  // use XmlHttpRequest to get string from server
  if ( (sxaction.readyState==4) || (sxaction.readyState==0) )
     {
     // ok to do it: set up as POST request to whatever
     sxaction.open("POST", "status.cgi", true);
     // set up function to be called when state changes
     sxaction.onreadystatechange = actionrtnret;
     sxaction.send(param);  // send it
     timeoutidc = window.setTimeout("timeoutrtnact();", 1000);
     }
  }

function actionrtnret()
  {
  var instr;
  var keypos;
  if ((sxaction.readyState==4) && (sxaction.status==200) )  
    {
    window.clearTimeout(timeoutidc);
    instr = sxaction.responseText;
    keypos = findkeypos(instr);
    if (instr.charAt(keypos) == "!")
	{
	// error condition: alert and return
	alert(instr);
	return;
	}
    // if ok - just do nothing
    }
  }


function timeoutrtnact()
  {
  // gets called if the xmlhttp request times out
  // clear it and reenable the window; also alert
  sxaction.abort();
  doalert("Request timed out");
  }

